var unreadCount = 0;
var TEXT_BOX = 'div.textarea';
var SEND_BTN = '.rootPanel button.styledButton.sendButton div div';
var nodeToBeClicked = "";
var isLinkAttached = false;

window.onload = function(){
    setTimeout(function(){
        removeNodeT('div.subscription[title="Premium"]');
        removeNodeT('div.feedbackButton');
    },10000);
    
    setTimeout(function(){
        clickNodeT('.teaser img.close');
    },10500);
    
    setTimeout(addMutationObserver,5000);
    setInterval(unReadCountUpdator,1000);
    setTimeout(addScheduler,5000);
    setTimeout(addReadAllNotification,4000);
};

document.onclick = function(e){
    var target = e.target;
    if(target.nodeName == "INPUT" && target.hasAttribute("type") && target.getAttribute("type") == "file"){
        if(!verGreaterThanTwelve){
            confirm('Media attachment for MySms service available on macOS Sierra(10.12) and above.');
        }
    }
};

this.Notification = function (title, options){
    webkit.messageHandlers.notification.postMessage(["MySms",title,options.body,getUnreadCount()]);
    
};
this.Notification.permission = 'granted';
this.Notification.requestPermission = function(callback) {callback('granted');};


function  removeNodeT(refNode){
    var referenceNode = document.querySelector(refNode);
    if(referenceNode){
        referenceNode.parentNode.removeChild(referenceNode);
    }
}

function clickNodeT(refNode){
    var referenceNode = document.querySelector(refNode);
    if(referenceNode){
        referenceNode.click();
    }
}

function unReadCountUpdator(){
    var tempCount = 0;
    tempCount = getUnreadCount();
    if(tempCount != unreadCount){
        webkit.messageHandlers.notification.postMessage(["MySms","count","MyCount",tempCount,null]);
        unreadCount = tempCount;
    }
}

//------------------------------------------------------
//@New Conversation & Logout
//------------------------------------------------------
function newConversation(){
    clickNodeT('div.composeMessage');
}

function logout(){
    clickNodeT('img.account');
    setTimeout(function(){
        clickNodeT('.accountOptionDialog .popupContent div.panel:last-child');
        webkit.messageHandlers.notification.postMessage(["messageSchedulerStatus","off"]);
    },300);
}

function getUnreadCount(){
    var total = 0;
    var unreadList = document.querySelectorAll('.x-unread .item div.unread span');
    if(unreadList){
        for(var i = 0; i < unreadList.length; i++){
            total += parseInt(unreadList[i].textContent)
        }
    }
    return total;
}

function replyForNotification(userid, replymsg){
    var chatList = "";
    chatList = document.querySelectorAll('.rootPanel .container .x-unread');
    var checkBool = false;
    
    checkBool = replyForNotificationForList(userid,replymsg,chatList);
    if(!checkBool){
        chatList = document.querySelectorAll('.rootPanel .container [_key]');
        replyForNotificationForList(userid,replymsg,chatList);
    }
}

function replyForNotificationForList(userid,replymsg, chatList){
    for(var i = 0; i < chatList.length; i++){
        var individualName = chatList[i].querySelectorAll('.name span')[0].textContent;
        
        if(individualName.indexOf('-') == -1){
            if(individualName.indexOf(userid)!=-1){
                chatList[i].click();
                setTimeout(function(){
                    var textEvent = document.createEvent('TextEvent');
                    textEvent.initTextEvent('textInput', true, true, null, replymsg, 9, "en-US");
                    document.querySelector(TEXT_BOX).focus();
                    document.querySelector(TEXT_BOX).dispatchEvent(textEvent);
                    setTimeout(function()
                               {
                        clickNodeT('.rootPanel button.styledButton.sendButton div div');
                    },100);
                    
                },300);
                return true;
            }
        }
    }
    return false;
}

//=========================================
//@Message Scheduler
//=========================================
function addScheduler(){
    if(document.querySelector('div.mainPanel .container')){
        webkit.messageHandlers.notification.postMessage(["messageSchedulerStatus","on"]);
        return true;
    } else {
        webkit.messageHandlers.notification.postMessage(["messageSchedulerStatus","off"]);
        return false;
    }
}

function schedule(){
    var nameOfUser = document.querySelector('div.container div.selected .item .name');
    if(nameOfUser){
        webkit.messageHandlers.notification.postMessage(["schedulemessage",nameOfUser.querySelectorAll('span')[0].textContent]);
    } else {
        openChatAlert();
    }
}

function addMutationObserver(){
    var target = document.querySelector('div.rootPanel ');
    // create an observer instance
    var observer = new MutationObserver(function(mutations)
                                        mutations.forEach(function(mutation){
        var target = mutation.target;
        if(target.querySelector('div.mainPanel')){
            removeNodeT('div.subscription[title="Premium"]');
            removeNodeT('div.feedbackButton');
            setTimeout(function(){
                clickNodeT('.teaser img.close');
                addScheduler();
                addReadAllNotification();
            },4000);
        } else {
            webkit.messageHandlers.notification.postMessage(["messageSchedulerStatus","off"]);
            webkit.messageHandlers.notification.postMessage(["readallnotificationstatus","off"]);
        }
    });
                                        });
    // configuration of the observer:
    var config = {childList: true};
    // pass in the target node, as well as the observer options
    if(target){
        observer.observe(target, config);
    }
}

//=========================================
//@Read All Messages
//=========================================
function addReadAllNotification(){
    if(document.querySelector('div.mainPanel .container')){
        webkit.messageHandlers.notification.postMessage(["readallnotificationstatus","on"]);
        return true;
    } else {
        webkit.messageHandlers.notification.postMessage(["readallnotificationstatus","off"]);
        return false;
    }
}

function readAllMessages(){
    var chatList = document.querySelectorAll('.rootPanel .container .x-unread');
    if(chatList){
        (function myLoop (i){
            setTimeout(function (){
                nodeToBeClicked = chatList[i-1];
                prompt("openwhatsappchat");//  your code here
                if (--i) myLoop(i);      //  decrement i and call myLoop again if i > 0
            },500);
            
        })(chatList.length);
    }
}

function openGivenChat(){
    nodeToBeClicked.click();
}

//-------------------------------------------------------
//@Sent From One Chat Link Attachment Handler
//-------------------------------------------------------

$(document).mouseenter(function(){
    addScheduler();
    addReadAllNotification();
    if (!isLinkAttached) {
        setTimeout(attachAppLink, 200);
    }
});

jQuery(document.body).on('click', SEND_BTN, function(e) {
    //    alert("click_SEND_BTN");
    if (!isLinkAttached) {
        setTimeout(attachAppLink, 200);
    }
    webkit.messageHandlers.notification.postMessage(["enableStickersButton", "off"]);
});
function attachAppLink() {
    var nameOfUser = document.querySelector('div.container div.selected .item .name').textContent;
    webkit.messageHandlers.notification.postMessage(["userChecker", "MySms", nameOfUser]);
}

function callBackForLinKAttach(messageText) {
    if (!isLinkAttached) {
        dispatch(document.querySelector(TEXT_BOX), 'textInput', messageText);
        isLinkAttached = true;
        triggerClick();
    }
}

function callBackForLinkAttachment(url) {
    var msg = " \nSent using \"One Chat\" - " + url;
    dispatch(document.querySelector(TEXT_BOX), 'textInput', msg);
    triggerClick();
}

function triggerClick() {
    var button = document.querySelector(SEND_BTN);
    if (button) {
        button.click();
    }
}
