var mutationObserverAdded = false;
var mutationObserverRestricter = false;
var TEXT_BOX = 'textarea.rc-message-box__textarea';
var unreadCountRef = 0;
var messageChecker = "";
var focusblur = "blured";
var observerDisconnected = false;
var activeChatClicked = false;

//-------------------------------------------------------
//@HTML5 Notification Handlers
//-------------------------------------------------------
this.Notification = function (title, options)
{
    //    alert("NOTIF RECEIVED");
    webkit.messageHandlers.notification.postMessage(["RocketChat",title,options.body,unreadCountRef,""]);
    checkUnreadCount();
};
this.Notification.permission = 'granted';
this.Notification.requestPermission = function(callback) {callback('granted');};

//--------------------------------------------------
//New Conversation & Logout
//--------------------------------------------------
function newConversation()
{
    var newButtonImage = document.querySelector("svg.sidebar__toolbar-button-icon--plus");
    if(newButtonImage) {
        newButtonImage.parentNode.click();
    }
//    clickNode('.toolbar-search__create-channel.icon-plus');
}

function logout()
{
    var menuButton = document.querySelector("button[aria-label=Options]");
    if(menuButton) {
        menuButton.click();
        setTimeout(function(){
                   var logoutButton = document.querySelector("li[data-id=logout]");
                   if(logoutButton) {
                   logoutButton.click();
                   }
                   }, 500);
    }
//    clickNode('header.header .account-box');
//    clickNode('#logout');
}

//--------------------------------------------------
//Event Listeners
//--------------------------------------------------
$(document).ready(function()
                  {
                  addMutationObserver();
                  setTimeout(function()
                             {
                             if($('body pre').text() == "Bad Gateway")
                             {
                             window.location.reload();
                             }
                             
                             },5000);
                  
                  
                  });

$(document).on('click', 'input[type = "file"]', function()
               {
               if(!verGreaterThanTwelve)
               {
               confirm('To upload media, drag and drop the file into the One Chat window.');
               }
               });

$(document).on('keyup',TEXT_BOX,function()
               {
                    spellCheckerOff(this);
               });

$(window).blur(function()
               {
               focusblur = "blured";
               });
$(window).focus(function()
                {
                focusblur = "focused";
                });

function spellCheckerOff(box)
{
    if(box.value.length>=1 && box.value.length<5)
    {
        //box.setAttribute("spellcheck",false);
    }
}


var shouldAddMutationObserver = true;
function addMutationObserver() {
    var target = document.querySelector(".rooms-list");
    //    alert("Mutation target "+target);
    if(target) {
        if(shouldAddMutationObserver) {
            var observer = new MutationObserver(function(mutations) {
                                                mutations.forEach(function(mutation) {
                                                                  //                                                                  alert("Mutation "+mutation.type);
                                                                  checkUnreadCount();
                                                                  });
                                                });
            
            var config = {attributes:true, childList:true, characterData:true, subtree:true};
            observer.observe(target, config);
            alert("Mutation Observer Added");
            shouldAddMutationObserver = false;
            checkUnreadCount();
        }
    }
    else {
        setTimeout(function(){
                   alert(this.location.pathname);
                   alert("call to add mutation observer");
                   addMutationObserver();
                   }, 2000);
    }
}
function checkUnreadCount() {
    var unreadChatList = document.querySelectorAll(".rooms-list li.sidebar-item--unread");
    alert(unreadChatList.length);
    var totalCount = 0;
    if(unreadChatList.length > 0) {
        var i;
        for(i=0; i<unreadChatList.length; i++) {
            var badge = unreadChatList[i].querySelector("span.badge");
            if(badge) {
                var count = parseInt(badge.textContent);
                totalCount = totalCount+count;
            }
        }
    }
    unreadCountRef = totalCount;
    webkit.messageHandlers.notification.postMessage(["RocketChat","count","RCCount",totalCount,null]);
}

//--------------------------------------------------
//Reply for Notification
//--------------------------------------------------
function replyForNotification(userid, replymsg)
{
    console.log("userid: "+userid+" msg: "+replymsg);
    var userList = document.querySelectorAll("a.sidebar-item__link");
    console.log(userList);
    if(userList.length<0)
    {
    }
    else
    {
        var j;
        for(j=0;j<userList.length;j++)
        {
            var item = userList[j];
            var individualName = item.querySelector("div.sidebar-item__name").innerText;
            console.log(individualName);
            var name = "@"+individualName;
            if(name.indexOf(userid)!=-1)
            {
                console.log("found "+name);
                item.click();
                setTimeout(function()
                           {
                           //document.querySelector(TEXT_BOX).value = replymsg;
                           var target = document.querySelector(TEXT_BOX);
                           var eventType = "textInput";
                           
                           alert("target "+target);
                           var evt = document.createEvent("TextEvent");
                           evt.initTextEvent (eventType, true, true, window, replymsg, 0, "en-US");
                           target.focus();
                           target.dispatchEvent(evt);

                           //$(TEXT_BOX).keyup();
                           setTimeout(function()
                                      {
                                      document.querySelector(".rc-message-box__icon.rc-message-box__send").click();
                                      //setTimeout(function(){this.location.reload();}, 100);
                                      },100);
//
                           },300);
            }
        }
    }
}

//=========================================
//@Auto Login Handlers
//=========================================
function clickLoginButton(formNode)
{
    if(document.querySelector('.submit button.login'))
    {
        document.querySelector('.submit button.login').click();
    }
}

