var TELEMSGTEST;
var TEXTBOXTG = 'div[data-placeholder="Message"]';
var SEARCHBOXTG = '#column-left > div > div > div.sidebar-header > div.input-search > input';
var SEND_BTN = 'div.btn-send-container button';
var totalTG = 0;
var dockCounterTG = 0;
var showMediaUploadAlert = true;
var isLinkAttached = false;

//----------------------------------------
//@Event Handlers
//----------------------------------------


var shouldAddChannelListObserver = true;

function addChannelListObserver() {
    var target = document.querySelector("#column-left");
    //    alert("Mutation target "+target);
    if (target) {
        if (shouldAddChannelListObserver) {
            var observer = new MutationObserver(function(mutations) {
                mutations.forEach(function(mutation) {
                    dockCountTG();
                });
            });
            
            var config = {
            attributes: true,
            childList: true,
            characterData: true,
            subtree: true
            };
            observer.observe(target, config);
            shouldAddChannelListObserver = false;
            dockCountTG();
        }
    } else {
        setTimeout(function() {
            addChannelListObserver();
        }, 2000);
    }
}
window.onload = function initialcaller() {
    if (navigator.appVersion.indexOf("10_11") > -1) {
        showMediaUploadAlert = true;
    } else {
        showMediaUploadAlert = false;
    }
    setInterval(dockCountTG, 2000);
    setTimeout(spellCheckerOff, 5000);
    setTimeout(addReadAllNotification, 5000);
    
    var tryDesktopClose = document.querySelector("body > div.page_wrap > div > div.login_try_desktop > span");
    if (tryDesktopClose) {
        tryDesktopClose.click();
    }
    
};


jQuery(document.body).on('keyup', TEXTBOXTG, function(e) {
    alert("keyup_TEXTBOXTG");
    var rect = document.querySelector(TEXTBOXTG).getBoundingClientRect();
    if (e.which === 32) {
        if (document.querySelector(TEXTBOXTG)) {
            var textInBox = document.querySelector(TEXTBOXTG).textContent;
            
            if (textInBox.length == 3) {
                webkit.messageHandlers.notification.postMessage(["enableStickersButton", "on", rect.bottom, rect.right]);
            }
            
            var numberOFWords = (textInBox.match(new RegExp(" ", "g")) || []).length;
            
            if (numberOFWords >= 0) {
                webkit.messageHandlers.notification.postMessage(["enableStickersButton", "on", rect.bottom, rect.right]);
            }
        }
    }
    
    
    if (e.which === 13) {
        if (!isLinkAttached) {
            attachAppLink();
        }
    } else {
        isLinkAttached = false;
    }
    if (document.querySelector(TEXTBOXTG).textContent.length == 3) {
        webkit.messageHandlers.notification.postMessage(["enableStickersButton", "on", rect.bottom, rect.right]);
    }
    
    if (e.which === 8 || e.which === 46) {
        if (document.querySelector(TEXTBOXTG).textContent.length < 3) {
            webkit.messageHandlers.notification.postMessage(["enableStickersButton", "off"]);
        }
    }
});

jQuery(document).on('click', 'input[type="file"]', function() {
    if (showMediaUploadAlert) {
        confirm('To upload media, drag and drop the file into the One Chat window.');
    }
});

jQuery(document).on('click', SEND_BTN , function(e) {
    if (!isLinkAttached) {
        attachAppLink();
    }
});


jQuery(document).on('click', 'div.tg_head_peer_title_wrap a.tg_head_btn', function(e) {
    setTimeout(faceTimeHandler, 50);
});

jQuery(document).on('click', 'ul.chatlist a', function(e) {
    //peer-title
    addScheduler();
    setTimeout(function() {
        spellCheckerOff();
    }, 500);
});

jQuery(document).on('click', 'ul.chatlist.chatlist-new.chatlist-48 a', function(e) {
    addScheduler();
    setTimeout(function() {
        spellCheckerOff();
    }, 500);
});

jQuery(document).mouseenter(function() {
    alert("mouseenter");
    if (!isLinkAttached) {
        attachAppLink();
    }
    addReadAllNotification();
    
});

$(window).focus(function() {
    var FTButton = document.querySelector('#faceTimeButtonContainer');
    if (FTButton) {
        webkit.messageHandlers.notification.postMessage(["facetime", "enable", "faceTimeButton"]);
    }
});

jQuery('body.osx.non_msie.is_1x').on('DOMNodeRemoved', function(e) {
    var elementRem = e.target;
    if (elementRem) {
        
        if (elementRem.nodeType === 1 && elementRem.hasAttribute('class')) {
            var elementRemClass = elementRem.getAttribute('class');
            if (elementRemClass) {
                if (elementRemClass.indexOf("modal-backdrop fade") != -1) {
                    webkit.messageHandlers.notification.postMessage(["facetime", "disable", "faceTimeButton"]);
                }
            }
        }
    }
    
    
});


function spellCheckerOff() {
    if ($(TEXTBOXTG).length) {
        $(TEXTBOXTG).attr("spellcheck", true);
    }
}

//----------------------------------------
//@Message Scheduling Handlers
//----------------------------------------
function addScheduler() {
    
    if ($('#column-center').length) {
        webkit.messageHandlers.notification.postMessage(["messageSchedulerStatus", "on"]);
        
        var nameOfUser = document.querySelector('#column-center > div > div > div.sidebar-header.topbar > div.chat-info > div > div > div.top > div > span');
        if (nameOfUser) {
            if (nameOfUser.textContent == "Telegram") {
                webkit.messageHandlers.notification.postMessage(["messageSchedulerStatus", "off"]);
                return false;
            }
        }
        
        return true;
    } else {
        webkit.messageHandlers.notification.postMessage(["messageSchedulerStatus", "off"]);
        return false;
    }
}

function schedule() {
    setTimeout(function() {
        //#column-center > div > div > div.sidebar-header.topbar > div.chat-info-container > div.chat-info > div > div > div.top > div > span
        var users = document.querySelectorAll("#column-center > div > div > div.sidebar-header.topbar > div.chat-info-container > div.chat-info > div > div > div.top > div > span");
        if (users.length > 0) {
            var imgURL = $('#column-center > div > div > div.sidebar-header.topbar > div.chat-info-container > div.chat-info > div > avatar-element > img');
            if (imgURL) {
                
                
                toDataUrl(imgURL.attr('src'), function(base64Img) {
                    
                    webkit.messageHandlers.notification.postMessage(["schedulemessage", users[0].textContent, "", base64Img]);
                    
                });
                
            } else {
                webkit.messageHandlers.notification.postMessage(["schedulemessage", users[0].textContent]);
            }
        } else {
            openChatAlert();
        }
    }, 0);
}

//----------------------------------------
//@Guggy GIFs Handlers
//----------------------------------------

function addCustomEmoji() {
    if ($('.im_media_attach_input').length) {
        prompt("attachGif");
        $('.im_media_attach_input').click();
    } else {
        selectAChatAlert();
    }
}

function sentenceForGuggyStickerSearch() {
    var sentence = "";
    if (document.querySelector(TEXTBOXTG)) {
        sentence = document.querySelector(TEXTBOXTG).textContent;
        //        webkit.messageHandlers.notification.postMessage(["enableStickersButton","off"]);
    }
    return sentence;
}

//----------------------------------------
//@FaceTime Calling Handlers
//----------------------------------------

function faceTimeHandler() {
    var profileName = document.querySelector('div.peer_modal_profile_name').textContent;
    var container = document.querySelector('div.md_modal_section_param_wrap');
    if (profileName == "Telegram ") {
        return;
    }
    var tagForMobileNumber = document.querySelector('div.md_modal_section_param_value').textContent;
    var mobileNo = tagForMobileNumber.replace('+', '');
    if (mobileNo.length > 0) {
        faceTimeButtonadder();
    }
}

function videoCall() {
    var faceTimeButton = document.querySelector('#faceTimeButton');
    faceTimeButton.click();
}

function audioCall() {
    var phoneCallButton = document.querySelector('#phoneCallButton');
    phoneCallButton.click();
}

function faceTimeButtonadder() {
    var faceTimeButton = document.createElement("input");
    faceTimeButton.setAttribute('id', "faceTimeButton");
    faceTimeButton.setAttribute('class', "faceTimeButton");
    faceTimeButton.setAttribute('type', "image");
    faceTimeButton.setAttribute('src', "https://gitlab.com/AY_Apps/1chat_app/raw/master/facetime_icn.png");
    faceTimeButton.style.width = "24px";
    faceTimeButton.style.height = "24px";
    
    var phoneCallButton = document.createElement("input");
    phoneCallButton.setAttribute('id', "phoneCallButton");
    phoneCallButton.setAttribute('class', "phoneCallButton");
    phoneCallButton.setAttribute('type', "image");
    phoneCallButton.setAttribute('src', "https://gitlab.com/AY_Apps/1chat_app/raw/master/call_icn.png");
    phoneCallButton.style.width = "22px";
    phoneCallButton.style.height = "22px";
    phoneCallButton.style.marginLeft = "10px";
    phoneCallButton.style.paddingBottom = "2px";
    var para = document.createElement("div");
    para.setAttribute('class', "faceTimeDiv");
    para.setAttribute('id', "faceTimeButtonContainer");
    para.appendChild(faceTimeButton);
    para.appendChild(phoneCallButton);
    
    var parentContainer = document.querySelector('div.md_modal_iconed_section_wrap.md_modal_iconed_section_number');
    parentContainer.appendChild(para);
    
    webkit.messageHandlers.notification.postMessage(["facetime", "enable", "faceTimeButton"]);
    
    jQuery(function($) {
        $('#faceTimeButton').on('click', function() {
            var profileName = document.querySelector('div.peer_modal_profile_name').textContent;
            var container = document.querySelector('div.md_modal_section_param_wrap');
            if (profileName == "Telegram ") {
                return;
            }
            var tagForMobileNumber = document.querySelector('div.md_modal_section_param_value').textContent;
            var mobileNo = tagForMobileNumber.replace('+', '');
            if (mobileNo.length > 0) {
                webkit.messageHandlers.notification.postMessage(["facetime", "Telegram", "faceTimeButton", mobileNo, profileName]);
            }
        });
        
        
        $('#phoneCallButton').on('click', function() {
            var profileName = document.querySelector('div.peer_modal_profile_name').textContent;
            var container = document.querySelector('div.md_modal_section_param_wrap');
            if (profileName == "Telegram ") {
                return;
            }
            var tagForMobileNumber = document.querySelector('div.md_modal_section_param_value').textContent;
            var mobileNo = tagForMobileNumber.replace('+', '');
            if (mobileNo.length > 0) {
                webkit.messageHandlers.notification.postMessage(["facetime", "Telegram", "phoneCallButton", mobileNo, profileName]);
            }
        });
        
        
    });
    
}

//----------------------------------------
//HTML5 Notification Handler
//----------------------------------------
this.Notification = function(title, options) {
    var x = document.getElementsByClassName("im_dialog_badge badge");
    var temp = 0;
    var i;
    totalTG = 0;
    if (x) {
        for (i = 0; i < x.length; i++) {
            temp = parseInt(x[i].innerHTML);
            totalTG = totalTG + temp;
        }
    }
    
    if (options.icon) {
        
        toDataUrl(options.icon, function(base64Img) {
            webkit.messageHandlers.notification.postMessage(["Telegram", title, options.body, totalTG, "", base64Img]);
        });
    } else {
        webkit.messageHandlers.notification.postMessage(["Telegram", title, options.body, totalTG]);
    }
};
this.Notification.permission = 'granted';
this.Notification.requestPermission = function(callback) {
    callback('granted');
};

//----------------------------------------
//@NewConversation and Logout
//----------------------------------------
function newConversation() {
    var event = new MouseEvent('click', {
        'view': window,
        'bubbles': true,
        'cancelable': true
    });
    document.querySelector("#new-menu").dispatchEvent(event);
    {
        var ctest = document.getElementsByClassName("dropdown-menu")[0];
        
        //var strTrans=ctest.getElementsByTagName('li')[2].innerText;
        
        var strTrans1 = ctest.getElementsByTagName('li')[1];
        
        var stra = strTrans1.getElementsByTagName('a')[0].click();
        
    }
}

function logout() {
    var event = new MouseEvent('click', {
        'view': window,
        'bubbles': true,
        'cancelable': true
    });
    
    
    document.querySelector(".tg_head_logo_dropdown.dropdown .tg_head_btn.dropdown-toggle").dispatchEvent(event);
    {
        var ctest = document.getElementsByClassName("dropdown-menu")[0];
        
        //var strTrans=ctest.getElementsByTagName('li')[2].innerText;
        if (ctest) {
            
            var strTrans1 = ctest.getElementsByTagName('li')[2];
            
            var stra = strTrans1.getElementsByTagName('a')[0].click();
        }
        
    }
    {
        var ctest = document.getElementsByClassName("md_modal_iconed_section_wrap  md_modal_iconed_section_link")[0];
        if (ctest) {
            var strTrans = ctest.getElementsByTagName('div')[5].innerText;
            
            var strTrans1 = ctest.getElementsByTagName('div')[5];
            
            var stra = strTrans1.getElementsByTagName('a')[0].click();
        }
        
        var ctest = document.getElementsByClassName("btn btn-md btn-md-primary")[0].click();
        
    }
}

function replyForNotification(useridTG, replymsgTG) {
    searchUserAndReply(useridTG, replymsgTG);
}

function searchUserAndReply(useridTG, replymsgTG) {
    setTimeout(function() {
        insertSearch(useridTG);
        setTimeout(function() {
            alert("insertSearch");
            var searchRecent = document.querySelectorAll("div.search-group-recent.search-group.search-group-contacts ul.chatlist a.chatlist-chat.rp");
            if(searchRecent.length > 0){
                alert("search[0].click()");
                //                searchRecent[0].click();
                var event = new MouseEvent('mousedown', {
                    'view': window,
                    'bubbles': true,
                    'cancelable': true
                });
                searchRecent[0].dispatchEvent(event);
                //                openGivenChat(search[0]);
                setTimeout(function() {
                    alert("insertMessage(replymsgTG);");
                    insertMessage(replymsgTG);
                    triggerClick();
                    if (!isLinkAttached) {
                        attachAppLink();
                    }
                    
                }, 500);
            } else {
                var search = document.querySelectorAll("div.search-group.search-group-contacts ul.chatlist a.chatlist-chat.rp");
                if(search.length > 0){
                    alert("search[0].click()");
                    //                    search[0].click();
                    var event = new MouseEvent('mousedown', {
                        'view': window,
                        'bubbles': true,
                        'cancelable': true
                    });
                    search[0].dispatchEvent(event);
                    //                    openGivenChat(search[0]);
                    setTimeout(function() {
                        alert("insertMessage(replymsgTG);");
                        insertMessage(replymsgTG);
                        triggerClick();
                        if (!isLinkAttached) {
                            attachAppLink();
                        }
                        
                    }, 500);
                }
            }
        }, 500);
    }, 500);
}

function insertSearch(searchText) {
    var searchbox = document.querySelector(SEARCHBOXTG);
    if(searchbox){
        var textEvent = document.createEvent('TextEvent');
        textEvent.initTextEvent('textInput', true, true, null, searchText, 9, "en-US");
        searchbox.dispatchEvent(textEvent);
        var msg = searchbox.textContent + " " + searchText;
        searchbox.textContent = msg;
        var event = new MouseEvent('mousedown', {
            'view': window,
            'bubbles': true,
            'cancelable': true
        });
        document.dispatchEvent(event);
    }
}

function triggerClick() {
    setTimeout(function() {
//        if (document.querySelector(TEXTBOXTG).length > 0) {
            alert("triggerClick document.querySelector(TEXTBOXTG).length > 0");
            autoClick = true;
            document.querySelector(TEXTBOXTG).focus();
            __triggerKeyboardEvent(document.querySelector(TEXTBOXTG),13,true);
            if(document.querySelector(SEND_BTN)){
                document.querySelector(SEND_BTN).click();
            }
            
            var els = document.querySelectorAll('.btn-send-container button');
            if(els.length > 0){
                els[0].click();
            }
            
//        } else {
//            alert("triggerClick document.querySelector(TEXTBOXTG).length == 0");
//        }
    }, 200);
}

function blobreader(urldown) {
    
    var xhr = new XMLHttpRequest;
    xhr.responseType = 'blob';
    
    xhr.onload = function() {
        var recoveredBlob = xhr.response;
        
        var reader = new FileReader;
        
        reader.onload = function() {
            var blobAsDataUrl = reader.result;
            downloadURI(blobAsDataUrl, "name");
            //window.location = blobAsDataUrl;
        };
        
        reader.readAsDataURL(recoveredBlob);
    };
    
    xhr.open('GET', urldown);
    xhr.send();
    
}


function downloadURI(uri, name) {
    var link = document.createElement("a");
    link.download = name;
    link.href = uri;
    document.body.appendChild(link);
    link.click();
    document.body.removeChild(link);
    delete link;
}

function toDataUrl(url, callback) {
    var xhr = new XMLHttpRequest();
    xhr.responseType = 'blob';
    xhr.onload = function() {
        var reader = new FileReader();
        reader.onloadend = function() {
            callback(reader.result);
        };
        reader.readAsDataURL(xhr.response);
    };
    xhr.open('GET', url);
    xhr.send();
}

function supressTGmbl() {
    
    setTimeout(function() {
        var ctest = document.getElementsByClassName("md_simple_modal_footer")[0];
        
        if (ctest) {
            var strTrans1 = ctest.getElementsByTagName('button')[0].click();
            return false;
        }
    }, 50);
}

function __triggerKeyboardEvent(el, keyCode, meta) {
    var eventObj = document.createEventObject ?
    document.createEventObject() : document.createEvent("Events");
    
    if (eventObj.initEvent) {
        eventObj.initEvent("keydown", true, true);
    }
    
    eventObj.keyCode = eventObj.which = keyCode;
    if (meta) {
        eventObj.metaKey = true;
    }
    
    el.dispatchEvent ? el.dispatchEvent(eventObj) : el.fireEvent("onkeydown", eventObj);
}

function notitele(totalTGn) {
    var i;
    var wraptest = document.getElementsByClassName("im_dialog_message_wrap")[0];
    var ctest = document.getElementsByClassName("im_dialog_message")[0];
    var strTrans = "";
    if (ctest) {
        strTrans = ctest.getElementsByTagName('span')[0].innerText;
    }
    if (totalTGn == null)
        totalTGn = 0;
    var usernametele;
    var usermessagetele;
    
    if (strTrans.indexOf("You: ") != -1) {
        return;
    }
    
    var c = document.getElementsByClassName("im_dialog_badge badge").length;
    
    if (c > 0) {
        var spans = wraptest.getElementsByTagName('div');
        usernametele = wraptest.getElementsByTagName('div')[0].textContent;
        usermessagetele = wraptest.getElementsByTagName('div')[2].textContent;
        
        var typingcheck = document.getElementsByClassName("im_short_message_service").length;
        if (typingcheck != 0) {
            return;
        }
        if (TELEMSGTEST != usernametele + usermessagetele) {
            webkit.messageHandlers.notification.postMessage(["Telegram", usernametele, usermessagetele, totalTGn]);
            TELEMSGTEST = usernametele + usermessagetele;
        }
    }
}

function removetglogoin() {
    var eletgin = document.querySelector('div.login_head_wrap a.login_head_logo_link');
    if (eletgin) {
        eletgin.parentNode.removeChild(eletgin);
    }
}

function dockCountTG() {
    
    var x = document.getElementsByClassName("dialog-subtitle-badge badge badge-24 unread");
    //var x = document.getElementsByClassName("Badge unread");
    var temp = 0;
    var i;
    totalTG = 0;
    for (i = 0; i < x.length; i++) {
        temp = parseInt(x[i].innerHTML);
        totalTG = totalTG + temp;
    }
    var y = document.getElementsByClassName("Badge muted unread");
    var j;
    
    for (j = 0; j < y.length; j++) {
        temp = parseInt(y[j].innerHTML);
        totalTG = totalTG + temp;
    }
    //    webkit.messageHandlers.notification.postMessage(["Telegram","count","TGCount",totalTG]);
    if (dockCounterTG != totalTG) {
        //        alert("dockCountTG_postMessage");
        dockCounterTG = totalTG;
        webkit.messageHandlers.notification.postMessage(["Telegram", "count", "TGCount", totalTG]);
        
        dockCounterTG = totalTG;
    } else
        return;
}

function attachAppLink() {
    alert("attachAppLink");
    if ($('#column-center').length) {
        var users = document.querySelectorAll("#column-center > div > div > div.sidebar-header.topbar > div.chat-info-container > div.chat-info > div > div > div.top > div > span");
        if (users.length > 0) {
            alert("nameOfUser");
            webkit.messageHandlers.notification.postMessage(["userChecker", "Telegram", users[0].textContent]);
        } else {
            alert("not_nameOfUser");
        }
    }
}

function callBackForLinKAttach(msgText) {
    alert("callBackForLinKAttach");
    if (!isLinkAttached) {
       
        setTimeout(function() {
            insertMessage(msgText);
            isLinkAttached = true;
            setTimeout(function() {
                triggerClick();
            }, 1500);
        }, 1500);
    }
}

function insertMessage(msgText) {
    var textEvent = document.createEvent('TextEvent');
    textEvent.initTextEvent('textInput', true, true, null, msgText, 9, "en-US");
    document.querySelector(TEXTBOXTG).dispatchEvent(textEvent);
    var msg = document.querySelector(TEXTBOXTG).textContent + " " + msgText;
    document.querySelector(TEXTBOXTG).textContent = msg;
}

function callBackForLinkAttachment(url) {
    
    
    
    setTimeout(function() {
        var msg = "\nSent using \"One Chat\" - " + url;
        var textEvent = document.createEvent('TextEvent');
        textEvent.initTextEvent('textInput', true, true, null, msg, 9, "en-US");
        document.querySelector(TEXTBOXTG).dispatchEvent(textEvent);
        setTimeout(function() {
            triggerClick();
        }, 1500);
    }, 1500);
}

function addReadAllNotification() {
    if ($('.im_dialogs_wrap').length) {
        webkit.messageHandlers.notification.postMessage(["readallnotificationstatus", "on"]);
        return true;
    } else {
        webkit.messageHandlers.notification.postMessage(["readallnotificationstatus", "off"]);
        return false;
    }
}

function readAllMessages() {
    //    var chatList = document.querySelectorAll('li.im_dialog_wrap a');
    //
    //    (function myLoop(i) {
    //        setTimeout(function() {
    //            nodeToBeClicked = chatList[i - 1];
    //            prompt("opentelegramchat"); //  your code here
    //            if (--i) myLoop(i); //  decrement i and call myLoop again if i > 0
    //        }, 500);
    //    })(chatList.length);
    //
    //    var newChatList = document.querySelectorAll('ul.chatlist li');
    //
    //    if (chatList.length == 0) {
    //        (function myLoop(i) {
    //            setTimeout(function() {
    //                nodeToBeClicked = newChatList[i - 1];
    //                prompt("opentelegramchat"); //  your code here
    //                if (--i) myLoop(i); //  decrement i and call myLoop again if i > 0
    //            }, 500);
    //        })(newChatList.length);
    //    }
    
}

function openGivenChat(nodeToBeClicked) {
    var event = new MouseEvent('mousedown', {
        'view': window,
        'bubbles': true,
        'cancelable': true
    });
    nodeToBeClicked.dispatchEvent(event);
}
