jQuery.noConflict();
var $ = jQuery;
//
this.Notification = function (title, options)
{
    alert("hello notification");
    webkit.messageHandlers.notification.postMessage(["TinderChat",title, options.body,0]);
};
this.Notification.permission = 'granted';
this.Notification.requestPermission = function(callback) {callback('granted');};

window.navigator.geolocation.permission = 'granted';
window.navigator.geolocation.requestPermission = function(callback) {callback('granted');};

var defaultPosition = { coords: {
latitude: 40.730610    ,
longitude: -73.935242,
},
timestamp: (new Date()).getTime()
};

var currentPosition = defaultPosition;

var accountNum = 0;
var totalUnreadCount = 0;
var shouldAddMsgObserver = true;
var shouldAddNotifObserver = true;
var shouldAddModalManagerObserver = true;
var shouldAddCenterContentChangeObserver = true;
var shouldAddLoginObserver = true;

(function(history){
 var pushState = history.pushState;
 history.pushState = function(state) {
 if (typeof history.onpushstate == "function") {
 history.onpushstate({state: state});
 }
 // whatever else you want to do
 // maybe call onhashchange e.handler
 return pushState.apply(history, arguments);
 }
 })(window.history);


window.onpopstate = history.onpushstate = function(e) {
    
    setTimeout(function() {
               //alert("history changed "+window.location.pathname);
               //addReadAllNotification();
               }, 100);
    
    setTimeout(function() {
               if(this.location.pathname.indexOf("/checkout") >= 0) {
               //               alert("CHECKOUT PAGE");
               resetToHomePath();
               }
               }, 500);
    
    setTimeout(function(){
               blockCertainPageContent();
               }, 500);
    setTimeout(function(){
               blockCertainPageContent();
               }, 1000);
    setTimeout(function(){
               blockCertainPageContent();
               }, 1500);
    
    setTimeout(function(){
               addReadAllNotification();
               }, 500);
};

window.onload = function()
{
    //alert("window onload");
    if(!navigator.geolocation) {
        //alert("location unavailable");
    }
    
    navigator.geolocation.watchPosition = function(position, error, options) {
        //alert("Watch "+currentPosition.coords.latitude+" "+currentPosition.coords.longitude);
        position(currentPosition);
    };
    
};

jQuery(document).on('click', 'a.navBar__profile-link', function (e) {
                    //                    alert('profile clicked');
                    addCenterContentChangeObserver();
                    setTimeout(blockCertainPageContent, 200);
                    });

jQuery(document).on('click', 'a.desktopNavbar__profile', function (e) {
                    //alert('profile clicked');
                    addCenterContentChangeObserver();
                    setTimeout(blockCertainPageContent, 200);
                    });

function resetToHomePath() {
    //    return;
    //alert(this.location.pathname);
    if(this.location.pathname === "/" || this.location.pathname === "/app/login" || this.location.pathname === "/app/matches" || this.location.pathname === "/app/logout") {
        //alert("reset: at home - "+this.location.pathname);
    }
    else {
        //alert("reset: not at home - "+this.location.pathname);
        //        this.location.href = this.location.origin;
        
        if(this.location.pathname.indexOf("/messages") >= 0) {
            clickNewMatchesButton();
        }
        else if(this.location.pathname.indexOf("/profile") >= 0) {
            performGoBack();
        }
        else {
            performGoBack();
            setTimeout(function(){
                       performGoBack();
                       }, 500);
        }
    }
}
function performGoBack() {
    //            alert("inside profile");
    var navBar = document.querySelector(".desktopNavbar");
    if(navBar) {
        //                alert("found navbar");
        var backButton = navBar.querySelector("a");
        if(backButton) {
            //                    alert("found back");
            backButton.click();
        }
    }
    
}

function addObservers() {
    addNotificationsObserver();
    
    setTimeout(addMessageBadgeObserver, 2000);
    
    addModalManagerObserver();
    
    addCenterContentChangeObserver();
    
    addLoginPageObserver();
    removeAppLinks();
    
    setTimeout(function(){
               addReadAllNotification();
               }, 3000);
}

function addNotificationsObserver() {
    var target = document.querySelector(".notificationManager");
    //alert("Tinder Notif "+target);
    if(target) {
        if(shouldAddNotifObserver) {
            var observer = new MutationObserver(function(mutations) {
                                                mutations.forEach(function(mutation) {
                                                                  alert(mutation.type);
                                                                  extractNotificationData(target);
                                                                  });
                                                });
            
            var config = {attributes:true, childList:true, characterData:true};
            observer.observe(target, config);
            alert("Tinder Notif Observer Added");
            shouldAddNotifObserver = false;
        }
    }
    else {
        setTimeout(function(){
                   addNotificationsObserver();
                   }, 2000);
    }
}
function addMessageBadgeObserver() {
    
    if(shouldAddMsgObserver) {
        setInterval(checkBadgeStatus, 3000);
        shouldAddMsgObserver = false;
    }
}

function addModalManagerObserver() {
    var target = document.querySelector("#modal-manager");
    //alert("Tinder Modal "+target);
    if(target) {
        if(shouldAddModalManagerObserver) {
            var observer = new MutationObserver(function(mutations) {
                                                mutations.forEach(function(mutation) {
                                                                  //alert("Tinder modal mutation "+mutation.type);
                                                                  removeAppLinks(target);
                                                                  //addCenterContentChangeObserver();
                                                                  });
                                                });
            
            var config = {attributes:true, childList:true, characterData:true};
            observer.observe(target, config);
            alert("Tinder Modal Observer Added");
            shouldAddModalManagerObserver = false;
        }
    }
    else {
        setTimeout(function(){
                   addModalManagerObserver();
                   }, 2000);
    }
}
function addLoginPageObserver() {
    var target = document.querySelector(".pageTransition");
    //alert("Tinder Login "+target);
    if(target) {
        if(shouldAddLoginObserver) {
            var observer = new MutationObserver(function(mutations) {
                                                mutations.forEach(function(mutation) {
                                                                  //alert("Tinder Login Mutation "+mutation.type);
                                                                  removeAppLinks(target);
                                                                  });
                                                });
            
            var config = {attributes:true, childList:true, characterData:true, subtree:true};
            observer.observe(target, config);
            alert("Tinder Login Observer Added");
            shouldAddLoginObserver = false;
            removeAppLinks();
        }
    }
    else {
        setTimeout(function(){
                   addLoginPageObserver();
                   }, 2000);
    }
}

function addCenterContentChangeObserver() {
    var target = document.querySelector(".App__body");
    //alert("Content "+target);
    blockCertainPageContent();
    setTimeout(blockCertainPageContent, 500);
    setTimeout(blockCertainPageContent, 1000);
    if(target) {
        if(shouldAddCenterContentChangeObserver) {
            var observer = new MutationObserver(function(mutations) {
                                                mutations.forEach(function(mutation) {
                                                                  //alert("Content mutation "+mutation.type);
                                                                  blockCertainPageContent();
                                                                  });
                                                });
            
            var config = {attributes:true, childList:true, characterData:true, subtree:true};
            observer.observe(target, config);
            alert("Content Observer Added");
            blockCertainPageContent();
            setTimeout(blockCertainPageContent, 500);
            setTimeout(blockCertainPageContent, 1000);
            shouldAddCenterContentChangeObserver = false;
        }
        else {
            setTimeout(function(){
                       addCenterContentChangeObserver();
                       }, 2000);
        }
    }
}

function checkBadgeStatus() {
    //alert("Check Badge Status");
    var matchListTitle = document.querySelector(".matchListTitle");
    if(matchListTitle) {
        var badge = document.querySelector(".matchListTitle__badge");
        if(badge) {
            webkit.messageHandlers.notification.postMessage(["TinderChat","count","",badge.innerText]);
        }
        else {
            webkit.messageHandlers.notification.postMessage(["TinderChat","count","","0"]);
        }
    }
    else {
        var messageList = document.querySelector(".messageList");
        if(messageList) {
            //alert("checking new item count");
            var messageItems = document.querySelectorAll(".messageListItem--isNew");
            totalUnreadCount = messageItems.length;
            webkit.messageHandlers.notification.postMessage(["TinderChat","count","",totalUnreadCount]);
        }
    }
}

function extractNotificationData(notif) {
    var title = document.querySelector(".notificationManager").querySelector(".Heading__title");
    alert("title "+title);
    if(title) {
        var subTitle = notif.querySelector(".Heading__subtitle").firstChild;
        totalUnreadCount = totalUnreadCount+1;
        
        var anchorElement = document.querySelector(".notificationManager").querySelector("a");
        var userID = "unknown";
        if(anchorElement) {
            userID = anchorElement.getAttribute("href");
        }
        alert(title.innerText+" "+subTitle.innerText+" "+userID);
        webkit.messageHandlers.notification.postMessage(["TinderChat",title.innerText,subTitle.innerText, userID,totalUnreadCount]);
    }
}
function removeAppLinks(target) {
    hideNativeAppLinks();
    setTimeout(function() {
               hideNativeAppLinks();
               }, 500);
    setTimeout(function() {
               hideNativeAppLinks();
               }, 1000);
    setTimeout(function() {
               hideNativeAppLinks();
               }, 2000);
    setTimeout(function() {
               hideNativeAppLinks();
               }, 3000);
    setTimeout(function() {
               hideNativeAppLinks();
               }, 4000);
    setTimeout(function() {
               hideNativeAppLinks();
               }, 5000);
    setTimeout(function() {
               hideNativeAppLinks();
               }, 6000);
    setTimeout(function() {
               hideNativeAppLinks();
               }, 7000);
    setTimeout(function() {
               hideNativeAppLinks();
               }, 8000);
    setTimeout(function() {
               hideNativeAppLinks();
               }, 9000);
    setTimeout(function() {
               hideNativeAppLinks();
               }, 10000);
    shouldAddCenterContentChangeObserver = true;
    
    //    alert(this.location.pathname);
    if(this.location.pathname != "/app/login" && this.location.pathname != "/app/profile" && this.location.pathname != "/app/logout" && this.location.pathname != "/app/settings" && this.location.pathname != "/app/profile/edit" && this.location.pathname != "/") {
        //alert("modal: not at home - "+this.location.pathname);
        
        var modalElement = document.querySelector(".modalManager");
        if(modalElement) {
            
            var productButton = modalElement.querySelectorAll(".productButton__button");
            //            alert("products button "+productButton+" "+productButton.length);
            if(productButton.length > 0) {
                alert("remove modal...");
                removeModal();
                return;
            }
            
            if(this.location.pathname.indexOf("/app/messages/") >= 0) {
                alert("inside messages");
                return;
            }
            
            alert("remove modal");
            
            removeModal();
            setTimeout(function(){removeModal();}, 100);
            setTimeout(function(){removeModal();}, 200);
            setTimeout(function(){removeModal();}, 500);
        }
    }
    else {
        //alert("modal: at home - "+this.location.pathname);
    }
}

function removeModal() {
    var modalManager = document.querySelector(".modalManager");
    $(modalManager).click();
    //    var buttons = modalManager.querySelectorAll(".button");
    //    if(buttons.length > 1) {
    //        alert("click cancel");
    //        var cancelButton = buttons[1];
    //        $(cancelButton).click();
    //    }
    //    else {
    //        alert("single button");
    //    }
}

function blockCertainPageContent() {
    //alert("blockContent");
    
    var plusButton = document.querySelector("[href='/app/settings/plus']");
    if(plusButton) {
        plusButton.style.display = "none";
    }
    
    var plusProduct = document.querySelectorAll(".settings__tinderPlusContainer");
    //alert("plus product "+plusProduct);
    if(plusProduct.length > 0) {
        var x;
        for(var i=0; i<plusProduct.length; i++) {
            x = plusProduct[i];
            //alert("plus product found "+x);
            if(x) {
                x.style.display = "none";
            }
        }
    }
    var goldProduct = document.querySelector(".settings__tinderGoldContainer");
    if(goldProduct) {
        goldProduct.style.display = "none";
    }
    
    var count = 0;
    
    if(this.location.pathname.indexOf("/settings/plus") >= 0) {
        count = count+1;
    }
    if(this.location.pathname.indexOf("/product/plus") >= 0) {
        count = count+1;
    }
    if(this.location.pathname.indexOf("/checkout") >= 0) {
        count = count+1;
    }
    if(this.location.pathname.indexOf("/product/gold") >= 0) {
        count = count+1;
    }
    
    if(count > 0) {
        var centerContent = document.querySelector(".desktop__main");
        if(centerContent) {
            //alert("found center content");
            var child = centerContent.firstChild;
            if(child) {
                //alert("found child");
                child.style.display = "none";
            }
        }
    }
    else {
        var centerContent = document.querySelector(".desktop__main");
        if(centerContent) {
            var child = centerContent.firstChild;
            if(child) {
                child.style.display = null;
            }
        }
    }
    
    var superLikeButton = document.querySelector(".recsGamepad__button--superlike");
    if(superLikeButton) {
        //alert('superlike button');
        superLikeButton.style.display = "none";
    }
    var boostButton = document.querySelector(".boostButtonWrapper");
    if(boostButton) {
        boostButton.style.display = "none";
    }
    var dislikeButton = document.querySelector(".recsGamepad__button--dislike");
    if(dislikeButton) {
        //alert('dislike button');
        dislikeButton.style.display = null;
    }
    
    var iconCombo = document.querySelector(".iconCombo");
    if(iconCombo) {
        var iconComboParent = iconCombo.parentNode;
        if(iconComboParent) {
            iconComboParent.style.display = "none";
        }
    }
    
    var popOverGetPlusButton = document.querySelector("div.profileCard__sliderContainer span.button__text");
    if(popOverGetPlusButton) {
        var popOverButtonParent = popOverGetPlusButton.parentNode;
        if(popOverButtonParent) {
            popOverButtonParent.style.display = "none";
        }
    }
}

function setAccountNumber(num) {
    accountNum = num;
}

function replyForNotification(userID, message) {
    
    alert("User: "+userID+" msg: "+message);
    
    //alert("path "+this.location.pathname);
    if(this.location.pathname === "/" || this.location.pathname === "/app/matches" || this.location.pathname === "/app/recs") {
        var msgList = document.querySelectorAll(".messageListItem");
        alert("msg list "+msgList.length);
        var x;
        for(var i=0;i<msgList.length;i++) {
            x = msgList[i];
            alert(x);
            if(userID == x.getAttribute("href")) {
                x.click();
                setTimeout(function() {
                           insertMessage(message)
                           }, 500);
            }
        }
    }
    else {
        alert("not at home");
        //this.location.href = this.location.origin;
        //setTimeout(sendReply.bind(userID, message, account), 8000);
    }
}
function insertMessage(message) {
    alert("insert message");
    var textField = document.querySelector(".sendMessageForm__input");
    if(!textField) {
        alert("textField is null");
    }
    dispatch(textField, "textInput", message);
}
function dispatch(target, eventType, char)
{
    alert("dispatch message");
    var evt = document.createEvent("TextEvent");
    evt.initTextEvent (eventType, true, true, window, char, 0, "en-US");
    target.focus();
    target.dispatchEvent(evt);
    
    setTimeout(clickOnSendButton, 1000);
    setTimeout(clickNewMatchesButton, 1500);
}
function clickOnSendButton() {
    alert("click send");
    $("[type='submit']").click();
}
function clickNewMatchesButton() {
    
    var discoverButton = document.querySelector(".discoverNewMatchesButton");
    if(discoverButton) {
        alert("click discover button");
        discoverButton.click();
    }
    else {
        var chatCloseButton = document.querySelector(".chatNavBar__button--back");
        if(chatCloseButton) {
            alert("click chatclose button");
            chatCloseButton.click();
        }
        else {
            var chatCloseButton2 = document.querySelector("a div.close");
            if(chatCloseButton2) {
                alert("click chatclose2 button");
                chatCloseButton2.click();
            }
            else {
                alert("unable to go back after send; reset to home");
                //resetToHomePath();
            }
        }
    }
}


function updatePosition (lat, long, ts) {
    //        alert("Update Position "+lat+" "+long);
    var newPos = {
    coords: {
    latitude:lat,
    longitude:long,
    },
    timestamp:ts
    };
    currentPosition = newPos;
    
    function geo_success(position) {
        //        alert("New Position\n"+JSON.stringify(position));
    }
    
    function geo_error() {
        alert("Sorry, no position available.");
    }
    
    var geo_options = {
    enableHighAccuracy: true,
        maximumAge        : 30000,
        timeout           : 27000
    };
    
    navigator.geolocation.watchPosition(geo_success, geo_error, geo_options);
}

function hideNativeAppLinks() {
    //alert('hide links called');
    var linksDiv = document.querySelector(".nativeAppsLinks");
    if(linksDiv) {
        //alert('links found');
        //        alert("Previous "+linksDiv.previousSibling);
        //
//        var prevEle = linksDiv.previousSibling;
//        if(prevEle) {
//            prevEle.parentNode.removeChild(prevEle);
//        }
        
        //linksDiv.style.display = "none";
        linksDiv.parentNode.removeChild(linksDiv);
    }
    
    var loginDiv = document.querySelector(".loginMobile");
    if(loginDiv) {
        var dwnLabel = loginDiv.childNodes[3];
        if(dwnLabel) {
            //alert("download label removed");
            dwnLabel.parentNode.removeChild(dwnLabel);
        }
    }
    
    handleHamburgerMenu();
}

function handleHamburgerMenu() {
    //alert("handle hamburger");
    var hamburgerMenuContent = document.querySelector(".hamburgerMenu__content");
    if(hamburgerMenuContent) {
        var hamburgerChild = hamburgerMenuContent.childNodes[0];
        //alert(hamburgerChild.childNodes.length);
        hamburgerChild.childNodes[1].style.display = "none";
        hamburgerChild.childNodes[2].style.display = "none";
    }
}

function addScheduler()
{
    if($("#main header div.pane-chat-controls").length)
    {
        webkit.messageHandlers.notification.postMessage(["messageSchedulerStatus","on"]);
        return true;
    }
    else
    {
        webkit.messageHandlers.notification.postMessage(["messageSchedulerStatus","off"]);
        return false;
    }
}
function addReadAllNotification()
{
    //alert("can read all msgs");
    if($("a.messageListItem").length > 0)
    {
        //alert("read msg ON");
        webkit.messageHandlers.notification.postMessage(["readallnotificationstatus","on"]);
        return true;
    }
    else
    {
        //alert("read msg OFF");
        webkit.messageHandlers.notification.postMessage(["readallnotificationstatus","off"]);
        return false;
    }
}

function readAllMessages()
{
    //alert("read msgs");
    var chatList = document.querySelectorAll("a.messageListItem");
    
    (function readChat(i) {
     setTimeout(function(){
                var node = chatList[i-1];
                openGivenChat(node);
                i--;
                if(i>0) readChat(i);
                }, 500)
     })(chatList.length);
}

function openGivenChat(node)
{
    //alert("open chat");
    //    var event = new MouseEvent('mousedown', { 'view': window, 'bubbles': true, 'cancelable': true });
    //    node.dispatchEvent(event);
    node.click();
}
function logout() {
    alert(this.location.pathname);
    if(this.location.pathname === "/app/profile") {
        findLogout();
    }
    else {
        $("div.desktopNavbar__avatar").click();
        findLogout();
    }
    
}
function findLogout() {
    var items = document.querySelectorAll("label.menuItem__contents button span");
    var i;
    for(i=0; i<items.length; i++) {
        var button = items[i];
        //        alert(button.textContent);
        if(button.textContent == "Logout") {
            button.click();
            setTimeout(function(){clickLogoutDialog()}, 500);
        }
    }
}
function clickLogoutDialog() {
    var items = document.querySelectorAll("div#modal-manager button");
    var i;
    for(i=0; i<items.length; i++){
        var button = items[i];
        if(button.textContent == "Logout") {
            button.click();
        }
    }
}

