var twitsCount = 0;
var showMediaUploadAlert = true;
var isMessagesLoaded = false;
var TEXTBOXSL = 'div[data-testid="dmComposerTextInput"]';
var SEND_BUTTON = 'div[data-testid="dmComposerSendButton"]';
var isLinkAttached = false;

var msgCount = 0;

//-------------------------------------------------------
//@HTML5 Notification Handlers
//-------------------------------------------------------
this.Notification = function(title, options) {
    alert("NOTIF RECEIVED");
};
this.Notification.permission = 'granted';
this.Notification.requestPermission = function(callback) {
    callback('granted');
};

jQuery(document).on('click', 'input[type="file"]', function() {
    if (showMediaUploadAlert) {
        confirm('To upload media, drag and drop the file into the One Chat window.');
    }
});

jQuery(document).on('keyup', '.rich-editor', function() {
    if (this.textContent.length >= 1 && this.textContent.length < 5) {
        //this.setAttribute("spellcheck",false);
    }
});

jQuery(document).mouseenter(function() {
    addReadAllNotification();
    
    if (!isLinkAttached) {
        attachAppLink();
    }
});


window.onload = function() {
    if (navigator.appVersion.indexOf("10_11") > -1) {
        showMediaUploadAlert = true;
    } else {
        showMediaUploadAlert = false;
    }
    addReadAllNotification();
    setInterval(checktwitcount, 4500);
    setInterval(loadMessages, 500);

};

var shouldAddMessagesObserver = true;

function addMessagesObserver() {
    var target = document.querySelector('div[data-testid="DMDrawerHeader"]');
    //    alert("Mutation target "+target);
    if (target) {
        if (shouldAddMessagesObserver) {
            var observer = new MutationObserver(function(mutations) {
                mutations.forEach(function(mutation) {
                    alert("Mutation " + mutation.type);
                    setTimeout(function() {
                        checktwitcount();
                    }, 2000);

                });
            });

            var config = {
                attributes: true,
                childList: true,
                characterData: true,
                subtree: true
            };
            observer.observe(target, config);
            alert("Mutation Observer Added");
            shouldAddMessagesObserver = false;
            checktwitcount();
        }
    } else {
        setTimeout(function() {
            //                   alert(this.location.pathname);
            //                   alert("call to add mutation observer");
            addMessagesObserver();
        }, 2000);
    }
}

function logout() {

    var profileDiv = document.querySelector('div[aria-label="Account menu"]');
    profileDiv.click();
    setTimeout(function() {
        var logoutLink = document.querySelector('a[href="/logout"]');
        logoutLink.click();
        //        var menuItems = document.querySelectorAll('div.css-1dbjc4n.r-1w50u8q a');
        //        var i;
        //        for (i = 0; i < menuItems.length; i++)
        //        {
        //            var temp = menuItems[i].getAttribute('data-testid');
        //            if (temp  == 'AccountSwitcher_Logout_Button')
        //            {
        //                menuItems[i].click();
        //            }
        //        }
        setTimeout(function() {
            var confirmLogout = document.querySelector('div[data-testid="confirmationSheetConfirm"]');
            confirmLogout.click();
        }, 200);

    }, 200);
}


function loadMessages() {
    if (isMessagesLoaded == false) {
        var messages = document.querySelector('a[data-testid="AppTabBar_DirectMessage_Link"]');
        if (messages) {
            messages.click();
            isMessagesLoaded = true;
        }
    }
}

function newConversation() {
    var newMessage = document.querySelector('a[data-testid="NewDM_Button"]');
    if (newMessage) {
        //On Messages Page
        newMessage.click();
    } else {
        var composeMessage = document.querySelector('div[aria-label="Compose new Message"]');
        if (composeMessage) {
            composeMessage.click();
        }

    }

}

function addCustomEmoji() {
    if ($('form.DMComposer div.photo-selector div.image-selector input.file-input').length) {
        prompt("attachGif");
        $('form.DMComposer div.photo-selector div.image-selector input.file-input').click();
    } else {
        if ($('div.tweet-content input.file-input').length) {
            prompt("attachGif");
            $('div.tweet-content input.file-input').click();
        } else {
            selectAChatAlert();
        }
    }
}

function addReadAllNotification() {
    var tabs = document.querySelectorAll("header.banner");
    //    if($('div.home-tweet-box').length)
    //    {
    //        webkit.messageHandlers.notification.postMessage(["readallnotificationstatus","on"]);
    //        return true;
    //    }
    //    else
    //    {
    //        webkit.messageHandlers.notification.postMessage(["readallnotificationstatus","off"]);
    //        return false;
    //    }
}

function readAllMessages() {
    document.querySelector('.js-new-tweets-bar').click();
}

function checktwitcount() {
    var repeatcheckcount = document.querySelector('div.stream-item div.new-tweets-bar');
    if (repeatcheckcount) {
        var temp = repeatcheckcount.getAttribute('data-item-count');
        if (temp != twitsCount) {
            //alert("Twit"+temp);
            twitsCount = temp;
            webkit.messageHandlers.notification.postMessage(["Twitter", "count", "TwitterCount", twitsCount]);
        }

    } else {
        if (twitsCount != 0) {
            twitsCount = 0;
            webkit.messageHandlers.notification.postMessage(["Twitter", "count", "TwitterCount", twitsCount]);
        }
    }


}


//=========================================
//@Auto Login Handlers
//=========================================
function clickLoginButton(formNode) {
    if (formNode) {
        formNode.submit();
    }
}


//=========================================
//@Message Scheduler
//=========================================

jQuery(document).on('click', 'div[data-testid="cellInnerDiv"]', function() {
    setTimeout(function(e) {
        addScheduler();
    }, 100);
});

function addScheduler() {
    alert("addScheduler");
    isLinkAttached = false;
    var infoButton = document.querySelector('a[aria-label="Conversation info"]');

    if (infoButton) {
        webkit.messageHandlers.notification.postMessage(["messageSchedulerStatus", "on"]);
        return true;
    } else {
        webkit.messageHandlers.notification.postMessage(["messageSchedulerStatus", "off"]);
        return false;
    }
}

function schedule() {

    var userElement = document.querySelector("h2#detail-header");
    setTimeout(function() {
        alert("schedule");
        if (userElement) {
            alert("userElement");
            var username = userElement.textContent;
            var userid = userElement.textContent;
            if (username) {
                alert("username");
                username = username.trim(); //replace(/\s/g,' ').
                webkit.messageHandlers.notification.postMessage(["schedulemessage", username, "", ""]);
            } else {
                alert("!username");
            }
        } else {
            openChatAlert();
        }
    }, 1000);

}


//=========================================
//@Reply from Notification
//=========================================
function replyForNotification(useridSL, replymsgSL) {
    //alert(useridSL + " " + replymsgSL);
//    alert(useridSL + " " + replymsgSL);
    var i;
    var displ = document.querySelectorAll('div[data-testid="cellInnerDiv"]');
//    alert(displ.length);

    for (i = 0; i < displ.length; i++) {
        var node = displ[i];

        var userNameTag = node.querySelector("span.css-901oao.css-16my406.r-poiln3.r-bcqeeo.r-qvutc0");
        if (userNameTag) {
//            alert(userNameTag);
            var tempun = userNameTag.textContent;
            //            alert(tempun);
            if (tempun) {
//                alert("tempun");
                if (useridSL.trim().indexOf(tempun.trim()) != -1) {
                    userNameTag.click();
//                    alert("matched");
                    //setTimeout(function(){
                    
                    setTimeout(function(e) {
                        var textEvent = document.createEvent('TextEvent');
                        textEvent.initTextEvent('textInput', true, true, window, replymsgSL, 0, "en-US");
                        document.querySelector(TEXTBOXSL).click();
                        document.querySelector(TEXTBOXSL).focus();
                        document.querySelector(TEXTBOXSL).dispatchEvent(textEvent);
                        __triggerKeyboardEvent(document.querySelector(TEXTBOXSL), 13, true);

                        setTimeout(function(e) {
                            var send = document.querySelector(SEND_BUTTON);
                            if(send){
                                send.click();
                            }
                        }, 100);

                    }, 500);

                    break;
                }
            }

        } else if (i == displ.length - 1) {
            //self.searchUserAndReply(useridSL, replymsgSL);
        }
    }
}

function searchUserAndReply(useridSL, replymsgSL) {
    var findFriendsSearch = document.querySelector("#app-mount > div.appDevToolsWrapper-1QxdQf > div > div.app-3xd6d0 > div > div.layers-OrUESM.layers-1YQhyW > div > div.container-1eFtFS > div > div.content-1SgpWY > div.sidebar-1tnWFu > nav > div.searchBar-3TnChZ > button");

    if (findFriendsSearch) {
        findFriendsSearch.click();
        setTimeout(function(e) {
            var inputSearch = document.querySelector('input[aria-label="Quick switcher"]');
            if (inputSearch) {
                //                var textEvent = document.createEvent('TextEvent');
                //                textEvent.initTextEvent('textInput', true, true, window, useridSL, 0, "en-US");
                //                document.querySelector(inputSearch).focus();
                //                document.querySelector(inputSearch).dispatchEvent(textEvent);
                inputSearch.setAttribute("value", useridSL);
                //                setTimeout(function(e) {
                //                    __triggerKeyboardEvent(document.querySelector(inputSearch), 13, true);
                //                }, 200);

                setTimeout(function(e) {
                    var results = document.querySelector('div[role="listbox"]');
                    var j = 0;
                    if (results) {
                        var userNameTags = results.querySelectorAll('div[role="option"]');
                        for (j = 0; j < userNameTags.length; j++) {
                            var userNameTag = userNameTags[j].querySelector("span");
                            //#quick-switcher-uid_88-item-0 > div > div.name-3qeTY- > span.match-20K5f5
                            if (userNameTag) {
                                alert(userNameTag);
                                if (userNameTag.indexOf(useridSL.trim()) != -1) {
                                    //                                    alert("MAtched");
                                    userNameTags[j].click();

                                    setTimeout(function(e) {
                                        var textEvent = document.createEvent('TextEvent');
                                        textEvent.initTextEvent('textInput', true, true, window, replymsgSL, 0, "en-US");
                                        //                alert(TEXTBOXSL);

                                        document.querySelector(TEXTBOXSL).focus();
                                        document.querySelector(TEXTBOXSL).dispatchEvent(textEvent);
                                        __triggerKeyboardEvent(document.querySelector(TEXTBOXSL), 13, true);

                                    }, 500);

                                }
                            }
                        }
                    } else {
                        alert("No Such Results");
                        return;
                    }


                }, 500);
            }

        }, 200);

    }
}


jQuery(document.body).on('click', SEND_BUTTON, function(e) {
    //    alert("click_SEND_BTN");
    if (!isLinkAttached) {
        setTimeout(attachAppLink, 200);
    }
    webkit.messageHandlers.notification.postMessage(["enableStickersButton", "off"]);
});


jQuery(document.body).on('keyup', TEXTBOXSL, function(e) {
    
    if (e.which === 13) {
        if (!isLinkAttached) {
            attachAppLink();
        }
    } else {
        isLinkAttached = false;
    }
});

function attachAppLink() {
    var nameOfUser = document.querySelector('h2#detail-header');
    if (nameOfUser) {
        webkit.messageHandlers.notification.postMessage(["userChecker", "Twitter", nameOfUser.textContent]);
    }
}

function callBackForLinKAttach(msgText) {
    if (!isLinkAttached) {
        var textEvent = document.createEvent('TextEvent');
        textEvent.initTextEvent('textInput', true, true, null, msgText, 9, "en-US");
        isLinkAttached = true;
        document.querySelector(TEXTBOXSL).dispatchEvent(textEvent);
        
        setTimeout(function(e) {
            __triggerKeyboardEvent(document.querySelector(TEXTBOXSL), 13, true);
            triggerClick();
        }, 2000);
    }
}

function callBackForLinkAttachment(url) {
    console.log(url);
    var msg = "Sent using \"One Chat\" - " + url;
    var textEvent = document.createEvent('TextEvent');
    textEvent.initTextEvent('textInput', true, true, null, msg, 9, "en-US");
    document.querySelector(TEXTBOXSL).dispatchEvent(textEvent);
    setTimeout(function(e) {
        __triggerKeyboardEvent(document.querySelector(TEXTBOXSL), 13, true);
        triggerClick();
    }, 2000);
}


function triggerClick() {
    setTimeout(function() {
//        if (document.querySelector(TEXTBOXTG).length > 0) {
            alert("triggerClick document.querySelector(TEXTBOXTG).length > 0");
            autoClick = true;
            document.querySelector(TEXTBOXSL).focus();
            __triggerKeyboardEvent(document.querySelector(TEXTBOXSL),13,true);
            if(document.querySelector(SEND_BUTTON)){
                document.querySelector(SEND_BUTTON).click();
            }
            
            var els = document.querySelectorAll('div[aria-label="Send"]');
            if(els.length > 0){
                els[0].click();
            }
    }, 500);
}

